/* wurzeltest.cc			letzte Aenderung: 16.7.2014 */
#define VERSION "Version 0.0"
/*
 Kurzbeschreibung: Testen von Wurzel-Funktionen

History:
14.7.2014	Erstellung (RP)
*/

#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string.h>
#include <math.h>

typedef unsigned short uint16;
typedef unsigned char uint8;

/************************* Vordeklarationen ***************************/
uint16 sqrt_u16(uint16 x);
uint16 sqrt_u16_variante2(uint16 x);
uint16 sqrt_u16_variante3(uint16 x);
uint16 sqrt_u16_variante4(uint16 x);

/************************* Globale Variablen **************************/

/**************** Routinen zur Parameterauswertung ********************/
#define MAXARG 1
static char argflag[128];
void setargflags(const char *s)
{
 int c;
 while(c= *s++)
  {if(c>='a' && c<='z')  c -= 'a'-'A';
   argflag[c&127]=1;
  }
}

/*************************** Kleinkram ********************************/
bool istja(const char *s)
{
 int c= *s;
 return (c=='j' || c=='J' || c=='y' || c=='Y');
}

/************** Klassen und Hauptteil des Programms *******************/


/************************* Hauptprogramm ******************************/
static int itotal=0;//test

int main(int argc,char *argv[])
{
 char quellname[80];
 int i,j,c;
 quellname[0]=0;
 if(sizeof(uint16)!=2) printf("sizeof(uint16)=%ld\n",(long)sizeof(uint16));
 if(argc<=0)
  {/* es wurde von WorkBench (GUI, Desktop, ...) gestartet */
  }
 else
  {/* es wurde von Shell (Terminal, Konsole, ...) gestartet */
   for(j=0,i=1;i<argc;i++)
	{if((c= *argv[i])=='-' || c=='?') setargflags(argv[i]);
	 else	{if(++j==1) strcpy(quellname,argv[i]);
	         //else if(j==2) strcpy(zielname,argv[i]);
	}	}
  }
 if(argflag['?'] || j>MAXARG)
	{printf("wurzeltest  %s\n",VERSION);
	 printf("Anwendung: wurzeltest\n");
	 exit(0);
	}

 int y;
 for(i=0;i<65285;i++)
  {
   y=sqrt_u16_variante4(i);
   if(y!=int(sqrt(double(i))+0.5))
    printf("%d: sqrt_y16-->%d  Korrekt: %d\n",i,y,int(sqrt(double(i))+0.5));
   /*
   if(i%10==0) printf("%6d%5d",i,y);
   else if(i%10==9) printf("%5d\n",y);
   else printf("%5d",y);
   */
  }
 printf("\n");
 printf("itotal=%d --> Durchschnittliche Iterationsschritte=%f\n",itotal,double(itotal)/(65285-256+1));

 return 0;
}/* ende von main */

uint16 sqrt_u16(uint16 x)
{
 uint16 a=16,b,a2;
 static int imax=0; int i=0;//test
 for(;;)
  {
   i++;//test
   a2=a;
   b=x/a; if(b>255) b=255;
   a=(a+b)/2;
   if(a==a2 || a==a2-1) break;
  }
 if(a<255)
  {
   a2=a*a;
   if(a2<x)
    {
     b=a+1;
     if(b*b-x < x-a2) a=b;
    }
  }
 if(i>imax || x<=16)//test
  {
   printf("%d-->%d Iterationsschritte: %d\n",x,a,i);//test
   imax=i;
  }
 return a;
}

uint16 sqrt_u16_variante2(uint16 x)
{
 uint16 a,b,a2=0;
 static int imax=0; int i=0;//test
 if(x>=64771) return 255;//8-Bit-Maximalwert
 for(a=16,b=x>>7; (b>>=2)!=0;) a<<=1;
 if(a>255) a=255;
 int startwert=a;//test
 if(x%1000==0) printf("x=%d Startwert=%d\n",x,a);//test
 for(;;)
  {
   i++;//test
   itotal++;//test
   //b=(x+a/2)/a;
   b=x/a; if((x%a)*2>a) b++;
   if(b>255) b=255;
   a2=a;
   a=(a+b)/2;
   if(a==a2) break;
   if(a==a2-1) break;
  }
 if(a*a<x)
  {
   b=a+1;
   if(b*b-x < x-a*a) a=b;
  }
 if(i>imax || x<=16)//test
  {
   printf("%d-->%d Iterationsschritte: %d (startwert=%d)\n",x,a,i,startwert);//test
   imax=i;
  }
 return a;
}

uint16 sqrt_u16_variante3(uint16 x)
{
 uint16 a=0,a2,b,mask;
 //if(x>=0x4000) a=0x80;

 for(mask=0x40,a=0x80,b=0x4000; x<b; mask>>=1,a>>=1,b>>=2) ;

 for(;mask!=0;mask>>=1)
  {
   itotal++;//test
   a |= mask;
   a2=a*a;
   if(a2==x) break;
   if(a2>x) a &= ~mask;
  }
 if(a!=255 && a2!=x)
  {
   b=a+1;
   if(b*b-x < x-a*a) a=b;
  }
 return a;
}

uint8 sqrt_u8(uint8 x)
{
 //es werden meist 4 Vergleiche gebraucht, bei >210 werden 5 gebraucht
 if(x>56)
  {
   if(x>132)
    {
     if(x>182)
      {
       if(x>210)
	{
	 if(x>240) return 16;
	 return 15;
	}
       return 14;
      }
     if(x>156) return 13;
     return 12;
    }
   if(x>90)
    {
     if(x>110) return 11;
     return 10;
    }
   if(x>72) return 9;
   return 8;
  }
 if(x>12)
    {
     if(x>30)
      {
       if(x>42) return 7;
       return 6;
      }
     if(x>20) return 5;
     return 4;
    }
 if(x>2)
    {
     if(x>6) return 3;
     return 2;
    }
 if(x==0) return 0;
 return 1;
}

uint16 sqrt_u16_variante4(uint16 x)
{
 uint16 a,b,a2,mask;
 //Startwert ermitteln:
 if(x>=0x1000)
  {
   if(x>=0x4000) a=0x80; else a=0x40;
  }
 else if(x>=256)
  {
   if(x>=0x400) a=0x20; else a=0x10;
  }
 else return sqrt_u8(x);
 mask = (a>>1);
 //Quadratwurzel berechnen:
 for(;mask!=0;mask>>=1)
  {
   itotal++;//test
   b=a;
   a |= mask; //Bit setzen
   a2=a*a;
   if(a2==x) return a; //Wenn gleich: Ergebnis ist exakter Wert
   if(a2>x) a=b; //Bit setzen zuruecknehmen
  }
 if(a!=255 && (a2=a*a)!=x)
  {
   b=a+1;
   if(b*b-x < x-a2) a=b;
  }
 return a;
}
